Subject: Re: bug#57503: 28.1.91; package-selected-packages should not be saved to custom-file

From: Robert Pluim <[email-masked]>
Date: Tue, 06 Sep 2022 15:49:29 +0200

>>>>> On Tue, 06 Sep 2022 12:34:00 +0200, Lars Ingebrigtsen <[email-masked]> said:

    Lars> Robert Pluim <[email-masked]> writes:
    >> How do we define 'fresher'?

    Lars> I left that as an exercise for the reader.  🫠  

    >> Anyway, if in doubt, use brute force:
    >> 
    >> (define-multisession-variable package-selected-packages-ms
    >> (package--find-non-dependencies))
    >> 
    >> works fine. We could even condition it on `package-selected-packages'
    >> being non-nil.

    Lars> Hm...  I wonder whether we could just drop the variable altogether.
    Lars> That is, checking for freshness sounds like as much work as
    Lars> recalculating the variable.

On further testing, using package--find-non-dependencies doesnʼt seem
to work 100% correctly: installing a package in emacs-29 and then
going back to emacs-28 has it showing up as 'dependency', not
'installed', in `list-packages'.

    Lars> What are the actual effects of the variable?  That is, what code is it
    Lars> supposed to speed up?

Itʼs supposed to allow people to deactivate packages without
uninstalling them, I think, although Iʼve never used it like that, and
Iʼm not 100% sure it works, since `package--find-non-dependencies'
looks in `package-alist', which I presume contains all the packages
found in .emacs.d/elpa

Thierry, you added the defcustom, is there any light you can shed
here? From my perspective we can stop updating the defcustom, but
there are bound to be people using it for something.

Robert
--